<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZ: scripts/4_World/Entities/ItemBase/VehicleBattery.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZ<span id="projectnumber">&#160;1.18.155069</span>
   </div>
   <div id="projectbrief">DayZ Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d9/d2c/_vehicle_battery_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">VehicleBattery.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d9/d2c/_vehicle_battery_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html">    1</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d3/d3c/class_vehicle_battery.html">VehicleBattery</a> : <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span>{</div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a1b4fb28895d01b2c70c0617b2bf9c2cb">    3</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a1b4fb28895d01b2c70c0617b2bf9c2cb">CanPutAsAttachment</a>( <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> parent )</div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span>    {</div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span>        <span class="keywordflow">if</span> (!super.CanPutAsAttachment(parent)) </div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span>        </div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span>        <span class="keywordtype">string</span> obj_type = parent.GetType();</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>        <span class="keywordflow">if</span> ( parent.IsInherited(<a class="code hl_function" href="../../de/d7a/class_item_base.html#ae4d149478b8fa76a947d145625a9fd0b">BatteryCharger</a>) )</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span>        {</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span>            <a class="code hl_function" href="../../de/d7a/class_item_base.html#ae4d149478b8fa76a947d145625a9fd0b">BatteryCharger</a> charger = <a class="code hl_function" href="../../de/d7a/class_item_base.html#ae4d149478b8fa76a947d145625a9fd0b">BatteryCharger</a>.Cast( parent );</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span>            <span class="keywordflow">return</span> charger.CanReceiveAttachment(<span class="keyword">this</span>, <a class="code hl_class" href="../../df/d36/class_inventory_slots.html">InventorySlots</a>.INVALID);</div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>        }</div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>        </div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().GetPluggedDevice())</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span>        </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>    }</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span>    </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a8f30cad3d2b47f9da1e0f96deaa7426c">   21</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a8f30cad3d2b47f9da1e0f96deaa7426c">CanDetachAttachment</a>( <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> parent )</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>    {</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    }</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>    </div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#ad59c82e4fa2138a19f29d26f6a5764a4">   26</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#ad59c82e4fa2138a19f29d26f6a5764a4">CanReceiveAttachment</a>( <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> attachment, <span class="keywordtype">int</span> slotId)</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>    {</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().IsPlugged())</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>        </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>        <span class="keywordflow">return</span> super.CanReceiveAttachment(attachment, slotId);</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>    }</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#ad746e8983b6d1af95ab721a493f66d26">   34</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#ad746e8983b6d1af95ab721a493f66d26">CanPutIntoHands</a>( <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> player ) </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    {</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        <span class="keywordflow">if</span> ( !super.CanPutIntoHands( parent ) )</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>        {</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        }</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>        </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        <span class="keywordflow">if</span> ( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a313b01e9b6139c20c69fb2b019da8008">HasEnergyManager</a>() )</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>        {</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>            <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> powered_device = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().GetPluggedDevice() ); <span class="comment">// Should return metal wire or barbed wire attachment</span></div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>            </div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>            <span class="keywordflow">if</span> ( powered_device  &amp;&amp;  powered_device.IsInherited( <a class="code hl_function" href="../../de/d7a/class_item_base.html#aad74df997c66faef4dde75c5ee3bf021">MetalWire</a> ) )</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>            {</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>            }</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>            <span class="keywordflow">else</span> <span class="keywordflow">if</span> (powered_device)</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>            {</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>            }</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        }</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>    }</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    </div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#ae06c239f22dc582e8ac2e861f6b95c4f">   58</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#ae06c239f22dc582e8ac2e861f6b95c4f">CanPutInCargo</a>( <a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> parent )</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>    {</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>        super.CanPutInCargo( parent );</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>        </div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>        <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> powered_device = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().GetPluggedDevice() ); <span class="comment">// Should return metal wire or barbed wire attachment</span></div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>            </div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <span class="keywordflow">if</span> ( powered_device )</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>        {</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>            <span class="comment">//We block placing in cargo if metal wire is plugged</span></div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>            <span class="comment">//metal wires plugged to batteries in cargo cause too many issues for little gameplay gain</span></div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>            <span class="keywordflow">if</span> ( powered_device.IsInherited( <a class="code hl_function" href="../../de/d7a/class_item_base.html#aad74df997c66faef4dde75c5ee3bf021">MetalWire</a> ) )</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>            {</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>            }</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        }</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>    }</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>    </div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a4fcef66968771656ccc51a842c6043b0">   76</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a4fcef66968771656ccc51a842c6043b0">OnInventoryEnter</a>(Man player)</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>    {</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        super.OnInventoryEnter(player);</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a0f26f3c0dabe69e8968903d31cf3638b">GetHierarchyParent</a>() == player || (<a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a0f26f3c0dabe69e8968903d31cf3638b">GetHierarchyParent</a>() &amp;&amp; <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a0f26f3c0dabe69e8968903d31cf3638b">GetHierarchyParent</a>().<a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a0fc522204b264247b969c1ed143d95d2">GetInventory</a>().GetCargo()))</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>        {</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>            <span class="keywordflow">if</span> ( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a313b01e9b6139c20c69fb2b019da8008">HasEnergyManager</a>() )</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>            {</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>                <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> powered_device = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().GetPluggedDevice() ); <span class="comment">// Should return metal wire or barbed wire attachment</span></div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>            </div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>                <span class="keywordflow">if</span> ( powered_device )</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>                {</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>                    <span class="keywordflow">if</span> ( powered_device.IsInherited( <a class="code hl_function" href="../../de/d7a/class_item_base.html#aad74df997c66faef4dde75c5ee3bf021">MetalWire</a> ) )</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>                    {</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>                        <span class="comment">//Unplug the device the wire is powering, but keep wire plugged to battery</span></div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>                        <span class="keywordflow">if</span> ( powered_device.GetCompEM().IsPlugged() )</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>                            powered_device.GetCompEM().UnplugDevice( powered_device.GetCompEM().GetPluggedDevice() );</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>                    }</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>                    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>                    {</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>                        this.<a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().<a class="code hl_function" href="../../d6/de6/class_component_energy_manager.html#a10b764e0c112ee44b645deb32188aeae">UnplugAllDevices</a>();</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>                    }</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>                }</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>            }</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>        }</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>    }</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>    </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a86f1410cea01605b8314d09e82147024">  103</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a86f1410cea01605b8314d09e82147024">OnMovedInsideCargo</a>(<a class="code hl_class" href="../../df/df9/class_entity_a_i.html">EntityAI</a> container)</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>    {</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>        super.OnMovedInsideCargo(container);</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        </div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        <span class="keywordflow">if</span> ( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a313b01e9b6139c20c69fb2b019da8008">HasEnergyManager</a>() )</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        {</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>            <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a> powered_device = <a class="code hl_class" href="../../de/d7a/class_item_base.html">ItemBase</a>.Cast( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().GetPluggedDevice() ); <span class="comment">// Should return metal wire or barbed wire attachment</span></div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>            </div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>            <span class="keywordflow">if</span> ( powered_device )</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>            {</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>                <span class="comment">//Should not be possible, but better safe than sorry</span></div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>                <span class="keywordflow">if</span> ( powered_device.IsInherited( <a class="code hl_function" href="../../de/d7a/class_item_base.html#aad74df997c66faef4dde75c5ee3bf021">MetalWire</a> ) )</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>                {</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>                    powered_device.GetCompEM().UnplugAllDevices();</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>                }</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>                <span class="keywordflow">else</span></div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>                {</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>                    this.<a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().<a class="code hl_function" href="../../d6/de6/class_component_energy_manager.html#a10b764e0c112ee44b645deb32188aeae">UnplugAllDevices</a>();</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>                }</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>            }</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>        }</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>    }</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>    </div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a03529f764e85fe4153336418b6a2e426">  126</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a03529f764e85fe4153336418b6a2e426">CanDisplayAttachmentSlot</a>( <span class="keywordtype">int</span> slot_id )</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    {</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>        <span class="keywordflow">if</span> ( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().IsPlugged() )</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>        <span class="keywordflow">return</span> super.CanDisplayAttachmentSlot( slot_id );</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>    }</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>    </div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#ab7f611c37afa639f555509d753629559">  133</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#ab7f611c37afa639f555509d753629559">DisplayNameRuinAttach</a>()</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>    {</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>    }</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    </div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#afba9833d8cfe497d25629e51506f6659">  138</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#afba9833d8cfe497d25629e51506f6659">ShowZonesHealth</a>()</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>    {</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>    }</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>    </div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a182115b173784e0e940e8202c78d188e">  143</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a182115b173784e0e940e8202c78d188e">SetActions</a>()</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>    {</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        super.SetActions();</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>        </div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        <span class="comment">//AddAction(ActionAttach);</span></div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>        <a class="code hl_function" href="../../dd/dfd/_advanced_communication_8c.html#a033d077df58807906c4dad3101d8768c">AddAction</a>(<a class="code hl_class" href="../../da/d7b/class_action_attach_on_selection.html">ActionAttachOnSelection</a>);</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>        <a class="code hl_function" href="../../dd/dfd/_advanced_communication_8c.html#a033d077df58807906c4dad3101d8768c">AddAction</a>(<a class="code hl_function" href="../../df/d5d/_action_detach_8c.html#a0d029c8f8d01c63cca13a523faf40996">ActionDetach</a>);</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>        <span class="comment">//AddAction(ActionAttachPowerSourceToPanel); SHOULD NOT BE USED ANYMORE</span></div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>        <a class="code hl_function" href="../../dd/dfd/_advanced_communication_8c.html#a033d077df58807906c4dad3101d8768c">AddAction</a>(<a class="code hl_class" href="../../d3/dbe/class_action_plug_target_into_this.html">ActionPlugTargetIntoThis</a>);</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>    }</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>    </div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a48e607edd98ca37b596424d453999b65">  154</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a48e607edd98ca37b596424d453999b65">OnQuantityChanged</a>(<span class="keywordtype">float</span> delta)</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>    {</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>        super.OnQuantityChanged(delta);</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>    }</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>    </div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>    <span class="comment">//------------------------------------</span></div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span><span class="comment"></span>    <span class="comment">//------------------------------------</span></div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>    </div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a7c4bd558b7011a60fc011e93903643a9">  163</a></span>    <span class="keyword">private</span> <span class="keywordtype">int</span>             <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#a7c4bd558b7011a60fc011e93903643a9">m_Efficiency0To10</a>; <span class="comment">// Synchronized variable</span></div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#aac834f573a1cff3144ef0e0e57814e95">  164</a></span>    <span class="keyword">static</span> <span class="keyword">private</span> <span class="keywordtype">float</span>    <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#aac834f573a1cff3144ef0e0e57814e95">m_EfficiencyDecayStart</a> = 0.1; <span class="comment">// At this % of maximum energy the output of the battery starts to weaken.</span></div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>    </div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a029dac5ea1ee50d7d5d781573533cc40">  166</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a029dac5ea1ee50d7d5d781573533cc40">VehicleBattery</a>()</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>    {</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#a7c4bd558b7011a60fc011e93903643a9">m_Efficiency0To10</a> = 10;</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>        <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a2bafff3bfbb6159d9707bd7ce7804f1c">RegisterNetSyncVariableInt</a>(<span class="stringliteral">&quot;m_Efficiency0To10&quot;</span>);</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        </div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>    }   </div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>    </div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#acadf5501d57d06baf19d1ff60650a989">  174</a></span>    <span class="keywordtype">float</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#acadf5501d57d06baf19d1ff60650a989">GetEfficiency0To1</a>()</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>    {</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#a7c4bd558b7011a60fc011e93903643a9">m_Efficiency0To10</a> * 0.1;</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    }</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>    </div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a5da425a155a09c3863e47676c05f8aa3">  180</a></span>    <span class="keywordtype">float</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a5da425a155a09c3863e47676c05f8aa3">GetEfficiencyDecayStart</a>()</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>    {</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#aac834f573a1cff3144ef0e0e57814e95">m_EfficiencyDecayStart</a>;</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>    }</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>    </div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>    <span class="comment">//Update Battery energy level before it overrides quantity</span></div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a1b1a91956e7dd8c1257a1f5f96e23fa2">  186</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a1b1a91956e7dd8c1257a1f5f96e23fa2">SetCEBasedQuantity</a>()</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>    {</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>        super.SetCEBasedQuantity();</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>        <span class="keywordflow">if</span> ( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>() )</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>            <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().<a class="code hl_function" href="../../d6/de6/class_component_energy_manager.html#aa949a780d8573da21f042a431278c862">SetEnergy</a>( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().GetEnergyMax() * ( <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#af5d57ac8a00fab716f6983223689ba4a">GetQuantity</a>() / <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a575a9a3ffd1ac6029401379ddd561cfb">GetQuantityMax</a>() ) );</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>    }</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>    </div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a339786d36818978f72c77e7d8737ff91">  193</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a339786d36818978f72c77e7d8737ff91">OnEnergyConsumed</a>()</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>    {</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>        super.OnEnergyConsumed();</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>        </div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>        <span class="keywordflow">if</span> ( <a class="code hl_function" href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a>().IsServer() )</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>        {</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>            <span class="keywordtype">float</span> energy_coef = <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().<a class="code hl_function" href="../../d6/de6/class_component_energy_manager.html#ac530f5c4891c8c8b2889930d5bb53c5e">GetEnergy0To1</a>();</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>            </div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>            <span class="keywordflow">if</span> ( energy_coef &lt; m_EfficiencyDecayStart  &amp;&amp;  m_EfficiencyDecayStart &gt; 0 )         </div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>            {</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>                <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#a7c4bd558b7011a60fc011e93903643a9">m_Efficiency0To10</a> = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga7a63fd1bc9f0c95f8021d8ece1b7500f">Round</a>(  (energy_coef / <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#aac834f573a1cff3144ef0e0e57814e95">m_EfficiencyDecayStart</a>) * 10  );</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>            }</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>            <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#ae4921a281934e14af9bab6c242049112">SetSynchDirty</a>();</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>        }</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>    }</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>        </div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>    <span class="comment">// BatteryCharging</span></div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno"><a class="line" href="../../d3/d3c/class_vehicle_battery.html#a077927f9b87baba6e4a27e09e1591805">  210</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3c/class_vehicle_battery.html#a077927f9b87baba6e4a27e09e1591805">OnEnergyAdded</a>()</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>    {</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>        super.OnEnergyAdded();</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>        </div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        <span class="keywordflow">if</span> ( <a class="code hl_function" href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a>().IsServer() )</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        {</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>            <span class="keywordtype">float</span> energy_coef = <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a>().<a class="code hl_function" href="../../d6/de6/class_component_energy_manager.html#ac530f5c4891c8c8b2889930d5bb53c5e">GetEnergy0To1</a>();</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>            </div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>            <span class="keywordflow">if</span> ( energy_coef &lt; m_EfficiencyDecayStart  &amp;&amp;  m_EfficiencyDecayStart &gt; 0)</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>            {</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>                <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#a7c4bd558b7011a60fc011e93903643a9">m_Efficiency0To10</a> = <a class="code hl_class" href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a>.<a class="code hl_function" href="../../d5/d98/group___math.html#ga7a63fd1bc9f0c95f8021d8ece1b7500f">Round</a>(  (energy_coef / <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#aac834f573a1cff3144ef0e0e57814e95">m_EfficiencyDecayStart</a>) * 10  );</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>                <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#ae4921a281934e14af9bab6c242049112">SetSynchDirty</a>();</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>            }</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>            {</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>                <a class="code hl_variable" href="../../d3/d3c/class_vehicle_battery.html#a7c4bd558b7011a60fc011e93903643a9">m_Efficiency0To10</a> = 10;</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>                <a class="code hl_function" href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#ae4921a281934e14af9bab6c242049112">SetSynchDirty</a>();</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>            }</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>        }</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>    }</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>}</div>
<div class="ttc" id="a3___game_2_entities_2_entity_a_i_8c_html_a0f26f3c0dabe69e8968903d31cf3638b"><div class="ttname"><a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a0f26f3c0dabe69e8968903d31cf3638b">GetHierarchyParent</a></div><div class="ttdeci">proto native EntityAI GetHierarchyParent()</div><div class="ttdoc">Returns direct parent of current entity.</div></div>
<div class="ttc" id="a3___game_2_entities_2_entity_a_i_8c_html_a0fc522204b264247b969c1ed143d95d2"><div class="ttname"><a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a0fc522204b264247b969c1ed143d95d2">GetInventory</a></div><div class="ttdeci">proto native GameInventory GetInventory()</div></div>
<div class="ttc" id="a3___game_2_entities_2_entity_a_i_8c_html_a2bafff3bfbb6159d9707bd7ce7804f1c"><div class="ttname"><a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a2bafff3bfbb6159d9707bd7ce7804f1c">RegisterNetSyncVariableInt</a></div><div class="ttdeci">proto native void RegisterNetSyncVariableInt(string variableName, int minValue=0, int maxValue=0)</div></div>
<div class="ttc" id="a3___game_2_entities_2_entity_a_i_8c_html_a313b01e9b6139c20c69fb2b019da8008"><div class="ttname"><a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a313b01e9b6139c20c69fb2b019da8008">HasEnergyManager</a></div><div class="ttdeci">bool HasEnergyManager()</div><div class="ttdoc">If this item has class EnergyManager in its config then it returns true. Otherwise returns false.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c_source.html#l02300">EntityAI.c:2300</a></div></div>
<div class="ttc" id="a3___game_2_entities_2_entity_a_i_8c_html_a575a9a3ffd1ac6029401379ddd561cfb"><div class="ttname"><a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a575a9a3ffd1ac6029401379ddd561cfb">GetQuantityMax</a></div><div class="ttdeci">int GetQuantityMax()</div><div class="ttdef"><b>Definition:</b> <a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c_source.html#l01820">EntityAI.c:1820</a></div></div>
<div class="ttc" id="a3___game_2_entities_2_entity_a_i_8c_html_a79cad88633d0faaa6fba7e7cbeb02c6a"><div class="ttname"><a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#a79cad88633d0faaa6fba7e7cbeb02c6a">GetCompEM</a></div><div class="ttdeci">ComponentEnergyManager GetCompEM()</div><div class="ttdef"><b>Definition:</b> <a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c_source.html#l02289">EntityAI.c:2289</a></div></div>
<div class="ttc" id="a3___game_2_entities_2_entity_a_i_8c_html_ae4921a281934e14af9bab6c242049112"><div class="ttname"><a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#ae4921a281934e14af9bab6c242049112">SetSynchDirty</a></div><div class="ttdeci">proto native void SetSynchDirty()</div><div class="ttdoc">Sets object synchronization dirty flag, which signalize that object wants to be synchronized (take ef...</div></div>
<div class="ttc" id="a3___game_2_entities_2_entity_a_i_8c_html_af5d57ac8a00fab716f6983223689ba4a"><div class="ttname"><a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c.html#af5d57ac8a00fab716f6983223689ba4a">GetQuantity</a></div><div class="ttdeci">float GetQuantity()</div><div class="ttdef"><b>Definition:</b> <a href="../../da/dc2/3___game_2_entities_2_entity_a_i_8c_source.html#l01815">EntityAI.c:1815</a></div></div>
<div class="ttc" id="a_action_detach_8c_html_a0d029c8f8d01c63cca13a523faf40996"><div class="ttname"><a href="../../df/d5d/_action_detach_8c.html#a0d029c8f8d01c63cca13a523faf40996">ActionDetach</a></div><div class="ttdeci">void ActionDetach()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d5d/_action_detach_8c_source.html#l00010">ActionDetach.c:10</a></div></div>
<div class="ttc" id="a_advanced_communication_8c_html_a033d077df58807906c4dad3101d8768c"><div class="ttname"><a href="../../dd/dfd/_advanced_communication_8c.html#a033d077df58807906c4dad3101d8768c">AddAction</a></div><div class="ttdeci">void AddAction(typename actionName)</div><div class="ttdef"><b>Definition:</b> <a href="../../dd/dfd/_advanced_communication_8c_source.html#l00219">AdvancedCommunication.c:219</a></div></div>
<div class="ttc" id="aclass_action_attach_on_selection_html"><div class="ttname"><a href="../../da/d7b/class_action_attach_on_selection.html">ActionAttachOnSelection</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d6/df4/_action_attach_on_selection_8c_source.html#l00001">ActionAttachOnSelection.c:2</a></div></div>
<div class="ttc" id="aclass_action_plug_target_into_this_html"><div class="ttname"><a href="../../d3/dbe/class_action_plug_target_into_this.html">ActionPlugTargetIntoThis</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d3c/_action_plug_target_into_this_8c_source.html#l00001">ActionPlugTargetIntoThis.c:2</a></div></div>
<div class="ttc" id="aclass_component_energy_manager_html_a10b764e0c112ee44b645deb32188aeae"><div class="ttname"><a href="../../d6/de6/class_component_energy_manager.html#a10b764e0c112ee44b645deb32188aeae">ComponentEnergyManager::UnplugAllDevices</a></div><div class="ttdeci">void UnplugAllDevices()</div><div class="ttdoc">Energy manager: Unplugs everything directly connected to this device.</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/df6/_component_energy_manager_8c_source.html#l00504">ComponentEnergyManager.c:504</a></div></div>
<div class="ttc" id="aclass_component_energy_manager_html_aa949a780d8573da21f042a431278c862"><div class="ttname"><a href="../../d6/de6/class_component_energy_manager.html#aa949a780d8573da21f042a431278c862">ComponentEnergyManager::SetEnergy</a></div><div class="ttdeci">void SetEnergy(float new_energy)</div><div class="ttdoc">Energy manager: Sets stored energy for this device. It ignores the min/max limit!</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/df6/_component_energy_manager_8c_source.html#l00523">ComponentEnergyManager.c:523</a></div></div>
<div class="ttc" id="aclass_component_energy_manager_html_ac530f5c4891c8c8b2889930d5bb53c5e"><div class="ttname"><a href="../../d6/de6/class_component_energy_manager.html#ac530f5c4891c8c8b2889930d5bb53c5e">ComponentEnergyManager::GetEnergy0To1</a></div><div class="ttdeci">float GetEnergy0To1()</div><div class="ttdoc">Energy manager: Returns % of stored energy this device has as float (from 0.0 to 1....</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/df6/_component_energy_manager_8c_source.html#l01185">ComponentEnergyManager.c:1185</a></div></div>
<div class="ttc" id="aclass_entity_a_i_html"><div class="ttname"><a href="../../df/df9/class_entity_a_i.html">EntityAI</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d45/3___game_2_entities_2_building_8c_source.html#l00001">Building.c:2</a></div></div>
<div class="ttc" id="aclass_inventory_slots_html"><div class="ttname"><a href="../../df/d36/class_inventory_slots.html">InventorySlots</a></div><div class="ttdoc">provides access to slot configuration</div><div class="ttdef"><b>Definition:</b> <a href="../../da/dc1/_inventory_slots_8c_source.html#l00005">InventorySlots.c:6</a></div></div>
<div class="ttc" id="aclass_item_base_html"><div class="ttname"><a href="../../de/d7a/class_item_base.html">ItemBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d82/4___world_2_entities_2_core_2_inherited_2_inventory_item_8c_source.html#l00516">InventoryItem.c:517</a></div></div>
<div class="ttc" id="aclass_item_base_html_aad74df997c66faef4dde75c5ee3bf021"><div class="ttname"><a href="../../de/d7a/class_item_base.html#aad74df997c66faef4dde75c5ee3bf021">ItemBase::MetalWire</a></div><div class="ttdeci">void MetalWire()</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3a/_metal_wire_8c_source.html#l00008">MetalWire.c:8</a></div></div>
<div class="ttc" id="aclass_item_base_html_ae4d149478b8fa76a947d145625a9fd0b"><div class="ttname"><a href="../../de/d7a/class_item_base.html#ae4d149478b8fa76a947d145625a9fd0b">ItemBase::BatteryCharger</a></div><div class="ttdeci">void BatteryCharger()</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2b/_battery_charger_8c_source.html#l00035">BatteryCharger.c:35</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html">VehicleBattery</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00001">VehicleBattery.c:2</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a029dac5ea1ee50d7d5d781573533cc40"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a029dac5ea1ee50d7d5d781573533cc40">VehicleBattery::VehicleBattery</a></div><div class="ttdeci">void VehicleBattery()</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00166">VehicleBattery.c:166</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a03529f764e85fe4153336418b6a2e426"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a03529f764e85fe4153336418b6a2e426">VehicleBattery::CanDisplayAttachmentSlot</a></div><div class="ttdeci">override bool CanDisplayAttachmentSlot(int slot_id)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00126">VehicleBattery.c:126</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a077927f9b87baba6e4a27e09e1591805"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a077927f9b87baba6e4a27e09e1591805">VehicleBattery::OnEnergyAdded</a></div><div class="ttdeci">override void OnEnergyAdded()</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00210">VehicleBattery.c:210</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a182115b173784e0e940e8202c78d188e"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a182115b173784e0e940e8202c78d188e">VehicleBattery::SetActions</a></div><div class="ttdeci">override void SetActions()</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00143">VehicleBattery.c:143</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a1b1a91956e7dd8c1257a1f5f96e23fa2"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a1b1a91956e7dd8c1257a1f5f96e23fa2">VehicleBattery::SetCEBasedQuantity</a></div><div class="ttdeci">override void SetCEBasedQuantity()</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00186">VehicleBattery.c:186</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a1b4fb28895d01b2c70c0617b2bf9c2cb"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a1b4fb28895d01b2c70c0617b2bf9c2cb">VehicleBattery::CanPutAsAttachment</a></div><div class="ttdeci">override bool CanPutAsAttachment(EntityAI parent)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00003">VehicleBattery.c:3</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a339786d36818978f72c77e7d8737ff91"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a339786d36818978f72c77e7d8737ff91">VehicleBattery::OnEnergyConsumed</a></div><div class="ttdeci">override void OnEnergyConsumed()</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00193">VehicleBattery.c:193</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a48e607edd98ca37b596424d453999b65"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a48e607edd98ca37b596424d453999b65">VehicleBattery::OnQuantityChanged</a></div><div class="ttdeci">override void OnQuantityChanged(float delta)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00154">VehicleBattery.c:154</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a4fcef66968771656ccc51a842c6043b0"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a4fcef66968771656ccc51a842c6043b0">VehicleBattery::OnInventoryEnter</a></div><div class="ttdeci">override void OnInventoryEnter(Man player)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00076">VehicleBattery.c:76</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a5da425a155a09c3863e47676c05f8aa3"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a5da425a155a09c3863e47676c05f8aa3">VehicleBattery::GetEfficiencyDecayStart</a></div><div class="ttdeci">float GetEfficiencyDecayStart()</div><div class="ttdoc">Returns efficiency of this battery. The value is synchronized from server to all clients and is accur...</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00180">VehicleBattery.c:180</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a7c4bd558b7011a60fc011e93903643a9"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a7c4bd558b7011a60fc011e93903643a9">VehicleBattery::m_Efficiency0To10</a></div><div class="ttdeci">private int m_Efficiency0To10</div><div class="ttdoc">ENERGY CONSUMPTION.</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00163">VehicleBattery.c:163</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a86f1410cea01605b8314d09e82147024"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a86f1410cea01605b8314d09e82147024">VehicleBattery::OnMovedInsideCargo</a></div><div class="ttdeci">override void OnMovedInsideCargo(EntityAI container)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00103">VehicleBattery.c:103</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_a8f30cad3d2b47f9da1e0f96deaa7426c"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#a8f30cad3d2b47f9da1e0f96deaa7426c">VehicleBattery::CanDetachAttachment</a></div><div class="ttdeci">override bool CanDetachAttachment(EntityAI parent)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00021">VehicleBattery.c:21</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_aac834f573a1cff3144ef0e0e57814e95"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#aac834f573a1cff3144ef0e0e57814e95">VehicleBattery::m_EfficiencyDecayStart</a></div><div class="ttdeci">static private float m_EfficiencyDecayStart</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00164">VehicleBattery.c:164</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_ab7f611c37afa639f555509d753629559"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#ab7f611c37afa639f555509d753629559">VehicleBattery::DisplayNameRuinAttach</a></div><div class="ttdeci">override bool DisplayNameRuinAttach()</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00133">VehicleBattery.c:133</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_acadf5501d57d06baf19d1ff60650a989"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#acadf5501d57d06baf19d1ff60650a989">VehicleBattery::GetEfficiency0To1</a></div><div class="ttdeci">float GetEfficiency0To1()</div><div class="ttdoc">Returns efficiency of this battery. The value is synchronized from server to all clients and is accur...</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00174">VehicleBattery.c:174</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_ad59c82e4fa2138a19f29d26f6a5764a4"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#ad59c82e4fa2138a19f29d26f6a5764a4">VehicleBattery::CanReceiveAttachment</a></div><div class="ttdeci">override bool CanReceiveAttachment(EntityAI attachment, int slotId)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00026">VehicleBattery.c:26</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_ad746e8983b6d1af95ab721a493f66d26"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#ad746e8983b6d1af95ab721a493f66d26">VehicleBattery::CanPutIntoHands</a></div><div class="ttdeci">override bool CanPutIntoHands(EntityAI player)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00034">VehicleBattery.c:34</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_ae06c239f22dc582e8ac2e861f6b95c4f"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#ae06c239f22dc582e8ac2e861f6b95c4f">VehicleBattery::CanPutInCargo</a></div><div class="ttdeci">override bool CanPutInCargo(EntityAI parent)</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00058">VehicleBattery.c:58</a></div></div>
<div class="ttc" id="aclass_vehicle_battery_html_afba9833d8cfe497d25629e51506f6659"><div class="ttname"><a href="../../d3/d3c/class_vehicle_battery.html#afba9833d8cfe497d25629e51506f6659">VehicleBattery::ShowZonesHealth</a></div><div class="ttdeci">override bool ShowZonesHealth()</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/d2c/_vehicle_battery_8c_source.html#l00138">VehicleBattery.c:138</a></div></div>
<div class="ttc" id="agameplay_8c_html_aebb1fa6632d513bc849994e7b6c9c93d"><div class="ttname"><a href="../../d8/d18/gameplay_8c.html#aebb1fa6632d513bc849994e7b6c9c93d">GetGame</a></div><div class="ttdeci">proto native CGame GetGame()</div></div>
<div class="ttc" id="agroup___math_html_d4/d34/class_math"><div class="ttname"><a href="../../d5/d98/group___math.html#d4/d34/class_math">Math</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/d34/_en_math_8c_source.html#l00006">EnMath.c:7</a></div></div>
<div class="ttc" id="agroup___math_html_ga7a63fd1bc9f0c95f8021d8ece1b7500f"><div class="ttname"><a href="../../d5/d98/group___math.html#ga7a63fd1bc9f0c95f8021d8ece1b7500f">Math::Round</a></div><div class="ttdeci">static proto float Round(float f)</div><div class="ttdoc">Returns mathematical round of value.</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_dc42280174b209627d8212c9e40d7e50.html">scripts</a></li><li class="navelem"><a class="el" href="../../dir_2e5c1ab951ac691cd4fc8c5e713c6c8a.html">4_World</a></li><li class="navelem"><a class="el" href="../../dir_d92b8e0605e989b70f343f78d41d5ad9.html">Entities</a></li><li class="navelem"><a class="el" href="../../dir_f12a6a0ceb954b09e80cdb3982c30e1e.html">ItemBase</a></li><li class="navelem"><a class="el" href="../../d9/d2c/_vehicle_battery_8c.html">VehicleBattery.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
